OGRE: Ogre::DefaultHardwareBufferManager Class Reference - OGRE Documentation

Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::DefaultHardwareBufferManager Class Reference
[RenderSystem]

DefaultHardwareBufferManager as a Singleton. More...

`#include <OgreDefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::DefaultHardwareBufferManager:
[legend]

List of all members.

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }
## Public Member Functions
| DefaultHardwareBufferManager ()
| ~DefaultHardwareBufferManager ()
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
virtual HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)=0
| Create a hardware vertex buffer.
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
virtual HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)=0
| Create a hardware index buffer.
RenderToVertexBufferSharedPtr | createRenderToVertexBuffer ()
virtual RenderToVertexBufferSharedPtr | createRenderToVertexBuffer ()=0
| Create a render to vertex buffer.
virtual VertexDeclaration * | createVertexDeclaration (void)
virtual VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration.
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
virtual VertexBufferBinding * | createVertexBufferBinding (void)
virtual VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding.
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another.
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.
virtual void | _freeUnusedBufferCopies (void)
virtual void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies.
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static HardwareBufferManager & | getSingleton (void)
| Override standard Singleton retrieval.
static HardwareBufferManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
## Protected Types
typedef set < HardwareVertexBuffer * > ::type | VertexBufferList
| WARNING: The following two members should place before all other members.
typedef set < HardwareIndexBuffer * > ::type | IndexBufferList
typedef set< VertexDeclaration * > ::type | VertexDeclarationList
typedef set < VertexBufferBinding * > ::type | VertexBufferBindingList
typedef multimap < HardwareVertexBuffer *, HardwareVertexBufferSharedPtr > ::type | FreeTemporaryVertexBufferMap
| Map from original buffer to temporary buffers.
typedef map < HardwareVertexBuffer *, VertexBufferLicense >::type | TemporaryVertexBufferLicenseMap
| Map from temporary buffer to details of a license.
## Protected Member Functions
virtual void | destroyAllDeclarations (void)
| Internal method for destroys all vertex declarations.
virtual void | destroyAllBindings (void)
| Internal method for destroys all vertex buffer bindings.
virtual VertexDeclaration * | createVertexDeclarationImpl (void)
| Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.
virtual void | destroyVertexDeclarationImpl (VertexDeclaration *decl)
| Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.
virtual VertexBufferBinding * | createVertexBufferBindingImpl (void)
| Internal method for creates a new VertexBufferBinding, may be overridden by certain rendering APIs.
virtual void | destroyVertexBufferBindingImpl (VertexBufferBinding *binding)
| Internal method for destroys a VertexBufferBinding, may be overridden by certain rendering APIs.
virtual HardwareVertexBufferSharedPtr | makeBufferCopy (const HardwareVertexBufferSharedPtr &source, HardwareBuffer::Usage usage, bool useShadowBuffer)
| Creates a new buffer as a copy of the source, does not copy data.
## Protected Attributes
HardwareBufferManagerBase * | mImpl
VertexBufferList | mVertexBuffers
IndexBufferList | mIndexBuffers
VertexDeclarationList | mVertexDeclarations
VertexBufferBindingList | mVertexBufferBindings
FreeTemporaryVertexBufferMap | mFreeTempVertexBufferMap
| Map of current available temp buffers.
TemporaryVertexBufferLicenseMap | mTempVertexBufferLicenses
| Map of currently licensed temporary buffers.
size_t | mUnderUsedFrameCount
| Number of frames elapsed since temporary buffers utilization was above half the available.
## Static Protected Attributes
static const size_t | UNDER_USED_FRAME_THRESHOLD
| Number of frames to wait before free unused temporary buffers.
static const size_t | EXPIRED_DELAY_FRAME_THRESHOLD
| Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.
static HardwareBufferManager * | ms_Singleton

## Detailed Description

DefaultHardwareBufferManager as a Singleton.

Definition at line 121 of file OgreDefaultHardwareBufferManager.h.

## Member Typedef Documentation

typedef multimap<HardwareVertexBuffer*, HardwareVertexBufferSharedPtr>::type Ogre::HardwareBufferManagerBase::FreeTemporaryVertexBufferMap`[protected, inherited]`

Map from original buffer to temporary buffers.

Definition at line 187 of file OgreHardwareBufferManager.h.

typedef set<HardwareIndexBuffer*>::type Ogre::HardwareBufferManagerBase::IndexBufferList`[protected, inherited]`

Definition at line 120 of file OgreHardwareBufferManager.h.

typedef map<HardwareVertexBuffer*, VertexBufferLicense>::type Ogre::HardwareBufferManagerBase::TemporaryVertexBufferLicenseMap`[protected, inherited]`

Map from temporary buffer to details of a license.

Definition at line 191 of file OgreHardwareBufferManager.h.

typedef set<VertexBufferBinding*>::type Ogre::HardwareBufferManagerBase::VertexBufferBindingList`[protected, inherited]`

Definition at line 126 of file OgreHardwareBufferManager.h.

typedef set<HardwareVertexBuffer*>::type Ogre::HardwareBufferManagerBase::VertexBufferList`[protected, inherited]`

WARNING: The following two members should place before all other members.

Members destruct order is very important here, because destructing other members will cause notify back to this class, and then will access to this two members.

Definition at line 119 of file OgreHardwareBufferManager.h.

typedef set<VertexDeclaration*>::type Ogre::HardwareBufferManagerBase::VertexDeclarationList`[protected, inherited]`

Definition at line 125 of file OgreHardwareBufferManager.h.

## Member Enumeration Documentation

enum Ogre::HardwareBufferManagerBase::BufferLicenseType`[inherited]`

Enumerator:

  BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
  BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.

Definition at line 153 of file OgreHardwareBufferManager.h.

## Constructor & Destructor Documentation

Ogre::DefaultHardwareBufferManager::DefaultHardwareBufferManager | ( |  | ) |

Definition at line 124 of file OgreDefaultHardwareBufferManager.h.

Ogre::DefaultHardwareBufferManager::~DefaultHardwareBufferManager | ( |  | ) |

Definition at line 129 of file OgreDefaultHardwareBufferManager.h.

References OGRE_DELETE.

## Member Function Documentation

virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) | `[virtual, inherited]`

Definition at line 477 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies().

virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) | `[virtual, inherited]`

Definition at line 483 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies().

virtual void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) | `[virtual, inherited]`

Internal method that forces the release of copies of a given buffer.

Remarks:
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters:

  | sourceBuffer | the source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

Referenced by Ogre::HardwareBufferManager::_forceReleaseBufferCopies().

virtual void Ogre::HardwareBufferManagerBase::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) | `[virtual, inherited]`

Internal method that forces the release of copies of a given buffer.

Remarks:
  This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes.

Parameters:

  | sourceBuffer | the source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

virtual void Ogre::HardwareBufferManagerBase::_freeUnusedBufferCopies | ( | void |  | ) | `[virtual, inherited]`

Free all unused vertex buffer copies.

Remarks:
  This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

Referenced by Ogre::HardwareBufferManager::_freeUnusedBufferCopies().

virtual void Ogre::HardwareBufferManager::_freeUnusedBufferCopies | ( | void |  | ) | `[virtual, inherited]`

Definition at line 467 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::_freeUnusedBufferCopies().

void Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) | `[inherited]`

Definition at line 493 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::_notifyIndexBufferDestroyed().

void Ogre::HardwareBufferManagerBase::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) | `[inherited]`

Notification that a hardware index buffer has been destroyed.

Referenced by Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed().

void Ogre::HardwareBufferManagerBase::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) | `[inherited]`

Notification that a hardware vertex buffer has been destroyed.

Referenced by Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed().

void Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) | `[inherited]`

Definition at line 488 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::_notifyVertexBufferDestroyed().

virtual void Ogre::HardwareBufferManager::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) | `[virtual, inherited]`

Definition at line 472 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::_releaseBufferCopies().

virtual void Ogre::HardwareBufferManagerBase::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) | `[virtual, inherited]`

Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.

Parameters:

  | forceFreeUnused | If true, free all unused temporary buffers. If false, auto detect and free all unused temporary buffers based on temporary buffers utilization.

Referenced by Ogre::HardwareBufferManager::_releaseBufferCopies().

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManager::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false` |
| ) |  |  | `[virtual, inherited]`

Definition at line 444 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::allocateVertexBufferCopy().

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false` |
| ) |  |  | `[virtual, inherited]`

Allocates a copy of a given vertex buffer.

Remarks:
  This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction.

Parameters:

  | sourceBuffer | The source buffer to use as a copy
  | licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  | licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  | copyData | If true, the current data is copied as well as the structure of the buffer

Referenced by Ogre::HardwareBufferManager::allocateVertexBufferCopy().

HardwareIndexBufferSharedPtr Ogre::HardwareBufferManager::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false` |
| ) |  |  | `[inherited]`

Definition at line 403 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::createIndexBuffer().

virtual HardwareIndexBufferSharedPtr Ogre::HardwareBufferManagerBase::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false` |
| ) |  |  | `[pure virtual, inherited]`

Create a hardware index buffer.

Remarks:
  Note that because buffers can be shared, they are reference counted so you do not need to worry about destroying them this will be done automatically.

Parameters:

  | itype | The type in index, either 16- or 32-bit, depending on how many vertices you need to be able to address
  | numIndexes | The number of indexes in the buffer
  | usage | One or more members of the HardwareBuffer::Usage enumeration.
  | useShadowBuffer | If set to true, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the index buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implemented in Ogre::DefaultHardwareBufferManagerBase.

Referenced by Ogre::HardwareBufferManager::createIndexBuffer().

RenderToVertexBufferSharedPtr Ogre::HardwareBufferManager::createRenderToVertexBuffer | ( |  | ) | `[inherited]`

Definition at line 410 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::createRenderToVertexBuffer().

virtual RenderToVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::createRenderToVertexBuffer | ( |  | ) | `[pure virtual, inherited]`

Create a render to vertex buffer.

Remarks:
  The parameters (such as vertex size etc) are determined later and are allocated when needed.

Implemented in Ogre::DefaultHardwareBufferManagerBase.

Referenced by Ogre::HardwareBufferManager::createRenderToVertexBuffer().

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false` |
| ) |  |  | `[pure virtual, inherited]`

Create a hardware vertex buffer.

Remarks:
  This method creates a new vertex buffer; this will act as a source of geometry data for rendering objects. Note that because the meaning of the contents of the vertex buffer depends on the usage, this method does not specify a vertex format; the user of this buffer can actually insert whatever data they wish, in any format. However, in order to use this with a RenderOperation, the data in this vertex buffer will have to be associated with a semantic element of the rendering pipeline, e.g. a position, or texture coordinates. This is done using the VertexDeclaration class, which itself contains VertexElement structures referring to the source data.
  Note that because vertex buffers can be shared, they are reference counted so you do not need to worry about destroying themm this will be done automatically.

Parameters:

  | vertexSize | The size in bytes of each vertex in this buffer; you must calculate this based on the kind of data you expect to populate this buffer with.
  | numVerts | The number of vertices in this buffer.
  | usage | One or more members of the HardwareBuffer::Usage enumeration; you are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY and useShadowBuffer=true.
  | useShadowBuffer | If set to true, this buffer will be 'shadowed' by one stored in system memory rather than GPU or AGP memory. You should set this flag if you intend to read data back from the vertex buffer, because reading data from a buffer in the GPU or AGP memory is very expensive, and is in fact impossible if you specify HBU_WRITE_ONLY for the main buffer. If you use this option, all reads and writes will be done to the shadow buffer, and the shadow buffer will be synchronised with the real buffer at an appropriate time.

Implemented in Ogre::DefaultHardwareBufferManagerBase.

Referenced by Ogre::HardwareBufferManager::createVertexBuffer().

HardwareVertexBufferSharedPtr Ogre::HardwareBufferManager::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false` |
| ) |  |  | `[inherited]`

Definition at line 396 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::createVertexBuffer().

virtual VertexBufferBinding* Ogre::HardwareBufferManager::createVertexBufferBinding | ( | void |  | ) | `[virtual, inherited]`

Definition at line 427 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::createVertexBufferBinding().

virtual VertexBufferBinding* Ogre::HardwareBufferManagerBase::createVertexBufferBinding | ( | void |  | ) | `[virtual, inherited]`

Creates a new VertexBufferBinding.

Referenced by Ogre::HardwareBufferManager::createVertexBufferBinding().

virtual VertexBufferBinding* Ogre::HardwareBufferManagerBase::createVertexBufferBindingImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for creates a new VertexBufferBinding, may be overridden by certain rendering APIs.

virtual VertexDeclaration* Ogre::HardwareBufferManagerBase::createVertexDeclaration | ( | void |  | ) | `[virtual, inherited]`

Creates a new vertex declaration.

Referenced by Ogre::HardwareBufferManager::createVertexDeclaration().

virtual VertexDeclaration* Ogre::HardwareBufferManager::createVertexDeclaration | ( | void |  | ) | `[virtual, inherited]`

Definition at line 416 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::createVertexDeclaration().

virtual VertexDeclaration* Ogre::HardwareBufferManagerBase::createVertexDeclarationImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.

virtual void Ogre::HardwareBufferManagerBase::destroyAllBindings | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for destroys all vertex buffer bindings.

virtual void Ogre::HardwareBufferManagerBase::destroyAllDeclarations | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for destroys all vertex declarations.

virtual void Ogre::HardwareBufferManager::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) | `[virtual, inherited]`

Definition at line 432 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::destroyVertexBufferBinding().

virtual void Ogre::HardwareBufferManagerBase::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) | `[virtual, inherited]`

Destroys a VertexBufferBinding.

Referenced by Ogre::HardwareBufferManager::destroyVertexBufferBinding().

virtual void Ogre::HardwareBufferManagerBase::destroyVertexBufferBindingImpl | ( | VertexBufferBinding * | binding | ) | `[protected, virtual, inherited]`

Internal method for destroys a VertexBufferBinding, may be overridden by certain rendering APIs.

virtual void Ogre::HardwareBufferManagerBase::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) | `[virtual, inherited]`

Destroys a vertex declaration.

Referenced by Ogre::HardwareBufferManager::destroyVertexDeclaration().

virtual void Ogre::HardwareBufferManager::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) | `[virtual, inherited]`

Definition at line 421 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::destroyVertexDeclaration().

virtual void Ogre::HardwareBufferManagerBase::destroyVertexDeclarationImpl | ( | VertexDeclaration * | decl | ) | `[protected, virtual, inherited]`

Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.

static HardwareBufferManager& Ogre::HardwareBufferManager::getSingleton | ( | void |  | ) | `[static, inherited]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< HardwareBufferManager >.

static HardwareBufferManager* Ogre::HardwareBufferManager::getSingletonPtr | ( | void |  | ) | `[static, inherited]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< HardwareBufferManager >.

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManagerBase::makeBufferCopy | ( | const HardwareVertexBufferSharedPtr & | source,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer |
| ) |  |  | `[protected, virtual, inherited]`

Creates a new buffer as a copy of the source, does not copy data.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy |
| ) |  |  | `[virtual, inherited]`

Registers a vertex buffer as a copy of another.

Remarks:
  This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

Referenced by Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy().

virtual void Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy |
| ) |  |  | `[virtual, inherited]`

Definition at line 437 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::registerVertexBufferSourceAndCopy().

virtual void Ogre::HardwareBufferManagerBase::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Manually release a vertex buffer copy for others to subsequently use.

Remarks:
  Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE.

Parameters:

  | bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

Referenced by Ogre::HardwareBufferManager::releaseVertexBufferCopy().

virtual void Ogre::HardwareBufferManager::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Definition at line 453 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::releaseVertexBufferCopy().

virtual void Ogre::HardwareBufferManagerBase::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Tell engine that the vertex buffer copy intent to reuse.

Remarks:
  Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames.

Parameters:

  | bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

Referenced by Ogre::HardwareBufferManager::touchVertexBufferCopy().

virtual void Ogre::HardwareBufferManager::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

Definition at line 460 of file OgreHardwareBufferManager.h.

References Ogre::HardwareBufferManagerBase::touchVertexBufferCopy().

## Member Data Documentation

const size_t Ogre::HardwareBufferManagerBase::EXPIRED_DELAY_FRAME_THRESHOLD`[static, protected, inherited]`

Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.

Definition at line 199 of file OgreHardwareBufferManager.h.

FreeTemporaryVertexBufferMap Ogre::HardwareBufferManagerBase::mFreeTempVertexBufferMap`[protected, inherited]`

Map of current available temp buffers.

Definition at line 189 of file OgreHardwareBufferManager.h.

HardwareBufferManagerBase* Ogre::HardwareBufferManager::mImpl`[protected, inherited]`

Definition at line 389 of file OgreHardwareBufferManager.h.

IndexBufferList Ogre::HardwareBufferManagerBase::mIndexBuffers`[protected, inherited]`

Definition at line 122 of file OgreHardwareBufferManager.h.

HardwareBufferManager * Ogre::Singleton< HardwareBufferManager >::ms_Singleton`[static, protected, inherited]`

Definition at line 75 of file OgreSingleton.h.

TemporaryVertexBufferLicenseMap Ogre::HardwareBufferManagerBase::mTempVertexBufferLicenses`[protected, inherited]`

Map of currently licensed temporary buffers.

Definition at line 193 of file OgreHardwareBufferManager.h.

size_t Ogre::HardwareBufferManagerBase::mUnderUsedFrameCount`[protected, inherited]`

Number of frames elapsed since temporary buffers utilization was above half the available.

Definition at line 195 of file OgreHardwareBufferManager.h.

VertexBufferBindingList Ogre::HardwareBufferManagerBase::mVertexBufferBindings`[protected, inherited]`

Definition at line 128 of file OgreHardwareBufferManager.h.

VertexBufferList Ogre::HardwareBufferManagerBase::mVertexBuffers`[protected, inherited]`

Definition at line 121 of file OgreHardwareBufferManager.h.

VertexDeclarationList Ogre::HardwareBufferManagerBase::mVertexDeclarations`[protected, inherited]`

Definition at line 127 of file OgreHardwareBufferManager.h.

const size_t Ogre::HardwareBufferManagerBase::UNDER_USED_FRAME_THRESHOLD`[static, protected, inherited]`

Number of frames to wait before free unused temporary buffers.

Definition at line 197 of file OgreHardwareBufferManager.h.

The documentation for this class was generated from the following file:

- OgreDefaultHardwareBufferManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:54